/*
 * Tuxcall -- Call waiting detector for Linux
 * Copyright (C) 2001-2002 Angel Luis Jimenez Martinez
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#   include <config.h>
#endif

#include <intl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <errno.h>


extern char ** environ;
extern int errno;
extern char HangCmd[];

void allocateBuff( signed short ** buff, float ** filtered, long buffLen )
{
    *buff= malloc( buffLen * sizeof(signed short) );
    *filtered= malloc( buffLen * sizeof(float) );
}

void freeBuff( signed short * buff, float * filtered )
{
    free( buff );
    free( filtered );
}

/*
 * Replaces system call
 */
int mySystem (const char * command)
{
    int pid, status;
    char * argv[4];

    if (command == 0)
        return 1;

    pid = fork();

    if (pid == -1)
        return -1;

    if (pid == 0) 
    {
        argv[0] = "sh";
        argv[1] = "-c";
        argv[2] = (char *)command;
        argv[3] = 0;
        execve("/bin/sh", argv, environ);
        exit(127);
    }

    do 
    {
        if (waitpid(pid, &status, 0) == -1) 
        {
            if (errno != EINTR)
                return -1;
        } else
            return status;
    } while(1);
}

/*
 * Hang connection
 */
void hang()
{
#ifdef DEBUG
    printf("HANG!!\n");
#endif    
    mySystem( HangCmd );
}

